<?php

function j2d_ttcn_createcck(&$context) {
  global $_joomla2drupal_vars;
  
//  db_query('DELETE FROM {node_type} WHERE type IN (\'gallery\', \'video\', \'software\')');
//  db_query('DELETE FROM {content_node_field} WHERE field_name NOT LIKE "field_thumb%"');
//  db_query('DELETE FROM {content_node_field_instance} WHERE field_name NOT LIKE "field_thumb%"');
//  content_clear_type_cache();
  
  db_query('DROP TABLE IF EXISTS {j2d_temp}');
//  $modulepath = drupal_get_path('module', 'joomla2drupal');
//  _joomla2drupal_create_content(file_get_contents($modulepath .'/cck-gallery.txt'));
//  _joomla2drupal_create_content(file_get_contents($modulepath .'/cck-software.txt'));
//  _joomla2drupal_create_content(file_get_contents($modulepath .'/cck-video.txt'));
}

function j2d_ttcn_mosvideo(&$matches) {
  $mpos = strpos($matches[2], '#');
  if ($mpos !== false) {
    $title = substr($matches[2], $mpos+1);
    $matches[2] = substr($matches[2], 0, $mpos);
  }
  if ($matches[1] == 'url') {
    $url = $matches[2];
    //remove unnecessary parts
    $url = preg_replace('/\/watch\?v=([\&]*)/', '/watch?v=\1', $url);
    $url = preg_replace('/\/videoplay\?docid=([^\&]*)\&/', '/videoplay?docid=\1', $url);
  }
  else switch ($matches[1]) {
    case 'youtube':
      $url = 'http://www.youtube.com/watch?v='. $matches[2];
      break;
    case 'google':
      $url = 'http://video.google.com/videoplay?docid='. $matches[2];
      break;
    case 'dailymotion':
      $url = 'http://www.dailymotion.com/video/'. $matches[2];
      break;
  }
  return "\n<p>$url $title</p>\n";
}

function j2d_ttcn_mambot($text) {
  global $_joomla2drupal_vars;
  
  $text = preg_replace_callback('/{video ([a-z]+)=(.+?)}/s', 'j2d_ttcn_mosvideo', $text);
  $text = preg_replace('/{style type=leftside}(.+?){\/style}/s', '<div class="s-side">\1</div>', $text);
  $text = preg_replace('/{style type=moreinfo}(.+?){\/style}/s', '<div class="s-moreinfo">\1</div>', $text);
  // replace very old style links
  $text = preg_replace('/"(|http:\/\/www\.thongtincongnghe\.com\/)content\/view\/(\d+)[0-9\/]*/', '"http://www.thongtincongnghe.com/article/\2', $text);

  $text = preg_replace('/ttcnStyle(\w+)/', 's-\1', $text);

  return $text;
}

function j2d_ttcn_preprocess(&$context) {
  module_disable(array('workflow', 'workflow_access', 'token', 'pathauto'));
  $tables = array('field_soft_article_id', 'field_soft_license', 'field_soft_os', 'field_thumbnail', 'field_video_urls', 'type_gallery', 'type_software', 'type_video', 'type_story');
  foreach ($tables as $tbl) {
//    db_query('DROP TABLE IF EXISTS {content_'. $tbl .'}');
    _joomla2drupal_reset_table_('content_'.$tbl);
  }
}

function j2d_ttcn_postprocess(&$context) {
  global $_joomla2drupal_vars;

  module_enable(array('workflow', 'workflow_access', 'token', 'pathauto'));

  if (module_exists('path')) {
    $aliases = array(
      '1' => 'me/about',
      '177' => 'me/copyright',
      '448' => 'me/ctv',
      '1899' => 'me/feeds',
      '2065' => 'me/help',
      '1345' => 'me/exchange',
      '5137' => 'me/ads',
      '4990' => 'me/reports',
      '1284' => 'ctv/sotay',
      '580' => 'ctv/noidung',
      '375' => 'ctv/trinhbay',
      '541' => 'ctv/quyuoc',
      '808' => 'ctv/canviet',
    );
    foreach ($aliases as $path=>$alias) {
      _joomla2drupal_set_alias('node/'. $path, $alias);
    }
    _joomla2drupal_set_roles(63, array(3,4,5));//nemo
    _joomla2drupal_set_roles(64, array(3,4,5));//hainam
    _joomla2drupal_set_roles(68, array(3,4));//tuanduc
    _joomla2drupal_set_roles(254, array(3,4,5));//tuong
    _joomla2drupal_set_roles(355, array(3));//manh
    _joomla2drupal_set_roles(371, array(3,4));//trung
    _joomla2drupal_set_roles(18897, array(3,4,5));//vinh
    _joomla2drupal_set_roles(20287, array(3));//vhp
    _joomla2drupal_set_roles(104, array(3));//buibinh
    _joomla2drupal_set_roles(1060, array(3));//manhtung
    _joomla2drupal_set_roles(1019, array(3,4,5));//tuan
    drupal_clear_path_cache();
  }
  
  // change vocabulary name from 'Topics' to 'Chủ đề'
  $query = "Update {vocabulary} set name = 'Chủ đề' " .
           "where name = 'Topics'";
  $result = db_query($query);

  // add new vocabulary 'Thể loại'
  $query = "INSERT INTO {vocabulary} (`name`, `help`, `relations`, `hierarchy`, `multiple`, `required`, `tags`, `module`, `weight`) " .
           "VALUES ('Thể loại', '', 1, 0, 0, 1, 0, 'taxonomy', -7);";
  $result = db_query($query);
  $vid = db_last_insert_id('vocabulary', 'vid');

  // Link 'Thể loại' to 'story'
  $query = "INSERT INTO {vocabulary_node_types} (`vid`, `type`) VALUES
           (%d, 'story');";
  $result = db_query($query, $vid);

  // Add new terms cho 'Thể loại'
  $query = "INSERT INTO {term_data} (`vid`, `name`) VALUES (%d, '%s')";
  db_query($query, $vid, 'Tin tức');
  $tid1 = db_last_insert_id('term_data', 'tid');
  db_query($query, $vid, 'Bài viết');
  $tid2 = db_last_insert_id('term_data', 'tid');
  db_query($query, $vid, 'Tài liệu');
  $tid3 = db_last_insert_id('term_data', 'tid');
  db_query($query, $vid, 'Nhận định');
  $tid4 = db_last_insert_id('term_data', 'tid');

  $query = "INSERT INTO `term_hierarchy` (`tid`, `parent`) VALUES (%d, 0), (%d, 0), (%d, 0), (%d, 0);";
  $result = db_query($query, $tid1, $tid2, $tid3, $tid4);

  // update 'Thể loại' vocabulary for 'story'
  j2d_ttcn_update_term('-Tin tức', $tid1);
  j2d_ttcn_update_term('-Bài viết', $tid2);
  
  // workflow
  $sid1 = db_result(db_query("SELECT sid FROM {workflow_states} WHERE state='Đã đăng'"));
  $sid2 = db_result(db_query("SELECT sid FROM {workflow_states} WHERE state='Chờ duyệt'"));
  $result = db_query('SELECT n.nid, n.uid, n.status, ws.state FROM {node} n INNER JOIN {workflow_type_map} wtm ON n.type=wtm.type LEFT JOIN {workflow_node} wn ON n.nid=wn.nid LEFT JOIN {workflow_states} ws ON wn.sid=ws.sid WHERE wtm.wid > 0');
  while ($node = db_fetch_object($result)) {
    if (empty($node->state)) { // i.e. 'No state'
      db_query('INSERT INTO {workflow_node} (nid, sid, uid, stamp) VALUES (%d, %d, %d, %d)', $node->nid, $node->status == 1 ? $sid1 : $sid2, 1, 0);
    }
  }
}

function j2d_ttcn_update_term($old_term, $new_tid) {
  $result = db_query("SELECT tid FROM {term_data} WHERE name = '%s'", $old_term);
  $tids = array();
  while ($tid = db_fetch_array($result)) {
    $tids[] = $tid['tid'];
  }
  db_query("UPDATE {term_node} SET tid = %d WHERE tid IN (%b)", $new_tid, implode(',', $tids));
  foreach ($tids as $tid) {
    taxonomy_del_term($tid);
  }
}

